////////////////////////////////////////////////////////////////////////////////////////////
// funcións de envío de código html para microservidor web
////////////////////////////////////////////////////////////////////////////////////////////
// función que envía liñas de texto html predefinidas
// así evítase ocupar a memoria de programa con cadenas repetidas
#include "html_funcions.h"

void html(byte indice)
{
  switch(indice)
  {
    case HTTP_OK:   cliente.println(F("HTTP/1.1 200 OK")); //envía tamén fin de liña
                    cliente.println(F("Content-Type: text/html")); //envía tamén fin de liña
                    //cliente.println(F("Connection: close"));  // pecha conexión despóis da resposta
                    html(CONNCLOSE); //usa a mesma función para non repetir cadena
                    cliente.println();
                    cliente.println(F("<!DOCTYPE HTML>")); break; 
    case CONNCLOSE: cliente.println(F("Connection: close")); cliente.println(); break; // pecha conexión despóis da resposta
    case GET:       cliente.print(F("GET /")); break;
    case FINGET:    cliente.println(F(" HTTP/1.1")); break; //engadir cr+lf ou println
    case HOST:      cliente.print(F("Host: ")); break;
    case HTML:      cliente.print(F("<HTML>")); break;
    case HTMLEND:   cliente.print(F("</HTML>")); break;
    case HEAD1:     cliente.print(F("<HEAD><META HTTP-EQUIV='CONTENT-TYPE' CONTENT='text/html; charset=UTF-8'>")); break;
    case HEADEND:   cliente.print(F("</HEAD>")); break;
    case VIEWPORT:  cliente.print(F("<meta name='viewport' content='width=device-width, initial-scale=1.0'>")); break;
    case REFRESH60: cliente.print(F("<META HTTP-EQUIV='REFRESH' CONTENT='60'>")); break;
    case BODY1:     cliente.print(F("<body lang='gl-ES' bgcolor='#5f5f9f' dir='ltr'>")); break;
    case BODYEND:   cliente.print(F("</body>")); break;
    case BR:        cliente.print(F("<br>")); break;
    case TABLE1:    cliente.print(F("<table width='386' cellpadding='4' cellspacing='0'>"));
                    cliente.print(F("<col width='376'>")); break;
    case TABLEEND:  cliente.print(F("</table>")); break;
    case TR:        cliente.print(F("<tr>")); break;
    case TREND:     cliente.print(F("</tr>")); break;
    case TD1:       cliente.print(F("<td width='376' valign='top' style='border: 1px solid #ffffff; padding: 0.1cm'>")); break;
    case TDEND:     cliente.print(F("</td>")); break;
    case FONTEND:   cliente.print(F("</font>")); break;
    case PLEFT:     cliente.print(F("<p align='left'>")); break;
    case PCENTER:   cliente.print(F("<p align='center'>")); break;
    case PEND:      cliente.print(F("</p>")); break;
    case BOLD:      cliente.print(F("<B>")); break;
    case BOLDEND:   cliente.print(F("</B>")); break;
    case ITAL:      cliente.print(F("<I>")); break;
    case ITALEND:   cliente.print(F("</I>")); break;
    case PUNTO:     cliente.print(F(".")); break;
    case FORMEND:   cliente.print(F("</FORM>")); break;

  } // fin do switch
}
////////////////////////////////////////////////////////////////////////////////////////////
// función que envía liñas de texto html predefinidas
// con 2 parámetros (cadenas curtas con texto ou números). 
// os parámetros poden ser nulos
void html2par(byte indice, char *cad1, char *cad2)
{
  switch(indice)
  {
    case FONTARIAL: //fonte Arial, cad1=cor (ex. "ffffff"), cad2=size (número enteiro)
        cliente.print(F("<font face='Arial, sans-serif' color='#")); cliente.print(cad1);
        cliente.print(F("' size='")); cliente.print(cad2); cliente.print(F("'>"));
      break;
    case INPUT1:   //envia campo de entrada tipo caixa de texto para número ip (3 díxitos 0-255)
        //con patrón de entrada para filtrar valores numéricos no rango 0-255
        cliente.print(F("<input type='text' name='")); cliente.print(cad1); //insire nome de campo
        cliente.print(F("' pattern='([1-9]?[0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])' value='"));
        cliente.print(cad2); cliente.print(F("' size='3' maxlength='3'>")); //insire valor do campo
      break;
    case INPUT2:   //envia campo de entrada tipo caixa de texto para datos servidor
        //con patrón de entrada para filtrar valores numéricos no rango 0-255
        cliente.print(F("<input type='text' name='")); cliente.print(cad1); //insire nome de campo
        cliente.print(F("' value='")); cliente.print(cad2); cliente.print(F("' size='30' maxlength='40'>")); //insire valor do campo
      break;
    case FORM1: //cabeceira de formulario con parámetros nome e acción (páxina destino)
        cliente.print(F("<FORM NAME='")); cliente.print(cad1); //nome do formulario
        cliente.print(F("' METHOD='GET' ACTION='")); cliente.print(cad2); //páxina destino
        cliente.print(F("'>"));
      break;
    case BUTTONOK:   //envia botón de envío de formulario con parámetro ok
        cliente.print(F("<button type='submit' name='ok' value='")); cliente.print(cad1); //insire valor de variable
        cliente.print(F("'>")); cliente.print(cad2); cliente.println(F("</button>")); //insire texto do botón
      break;
  } // fin do switch
}
/////////////////////////////////////////////////////////////////////////////////////////////////
// función auxiliar que define a fonte arial indicando cor e tamaño
// parámetros cor (branco=0xLffffff) e tamaño (3,5,7...)
void html_fontarial(unsigned long cor, byte tam)
{
  sprintf(cad1,"%lx",cor); sprintf(cad2,"%d",tam);
  html2par(FONTARIAL,cad1,cad2);  
}

/////////////////////////////////////////////////////////////////////////////////////////////////
// función auxiliar que envia unha liña de campo ip indicando o número de variable e o seu valor
// parámetros num (vale 0..20, xera un nome tipo "ip%02d") e valor (byte)
void html_campo_ip(byte num, byte val)
{
  sprintf(cad1,"ip%02d",num); sprintf(cad2,"%d",val);    
  html2par(INPUT1,cad1,cad2);
}

/////////////////////////////////////////////////////////////////////////////////////////////////
// esta función envía o código html da páxina de presentación do medidor
// para non ocupar demasiada memoria emprega un conxunto de liñas predefinidas 
// a través da función auxiliares html() (sen parámetros) e html2par() (recibe 2 cadenas)
void paxina_html_inicio()
{
  html(HTTP_OK); //cabeceira da páxina
  
  html(HTML); //inicio de código html
  html(HEAD1); //<head> con content-type
  html(VIEWPORT); //orden para adaptarse ao tamaño de pantalla
  html(REFRESH60); //orden para recargar a páxina cada 60 segundos
  html(HEADEND); //fin de cabeceira
  html(BODY1); //inicio de texto con idioma e cor de fondo
  html(BR); //salto de liña
  html(PLEFT);html(BOLD);
  html_fontarial(0xffffff,5);
  cliente.print(F("Proxecto Medidor Ambiental"));
  html(FONTEND); html(BOLDEND); html(PEND);
  html(PLEFT);html(ITAL);
  html_fontarial(0xffffff,2);
  cliente.print(F("IES Escolas Proval - IES Val Mi&ntilde;or - Hermes Smart Control"));
  html(BR); //salto de liña
  html(FONTEND); html(ITALEND); html(PEND);
  
  html(PLEFT);html(BOLD);
  html_fontarial(0xffffff,4);
  cliente.print(F("MEDIDOR ")); cliente.print(medidor_numero);
  html(FONTEND); html(BOLDEND); html(PEND);

  html(TABLE1); //inicio de tabla con ancho 386 e columna 376
  html(TR); //inicio de fila
  html(TD1); //parámetros de cela: ancho, estilo borde
  //formato de párrafo: centrado, fonte arial, branca, tamaño 7
  html(PCENTER); html(BOLD); 
  html_fontarial(0xffffff,7);
  //valor co2
  if(CO2==0xffff) strcpy(cad1,"---"); //saida nula
  else 
    converte_co2_texto(cad1,CO2); //función específica para convertir datos a texto
  cliente.print(F("CO<sub>2</sub>: ")); cliente.print(cad1); cliente.print(F(" ppm"));
  html(BOLDEND); html(FONTEND); html(PEND); 
  html(TDEND); html(TREND); 
  
  html(TR); //inicio de fila
  html(TD1); //parámetros de cela: ancho, estilo borde
  //formato de párrafo: centrado, fonte arial, branca, tamaño 7
  html(PCENTER); html(BOLD);
  html_fontarial(0xffffff,7);
  //valor temp
  if(TEMP==0xffff) strcpy(cad1,"---"); //saida nula
  else 
    converte_temperatura_texto(cad1,TEMP); //función específica para convertir datos a texto
  cliente.print(F("Temp: ")); cliente.print(cad1); cliente.print(F("&ordm;C"));
  html(BOLDEND); html(FONTEND); html(PEND); 
  html(TDEND); html(TREND); 

  html(TR); //inicio de fila
  html(TD1); //parámetros de cela: ancho, estilo borde
  //formato de párrafo: centrado, fonte arial, branca, tamaño 7
  html(PCENTER); html(BOLD); 
  html_fontarial(0xffffff,7);
  // valor hum
  if(HUM==0xffff) strcpy(cad1,"---"); //saida nula
  else 
    converte_humidade_texto(cad1,HUM); //función específica para convertir datos a texto
  cliente.print(F("Hum: ")); cliente.print(cad1); cliente.print(F("%"));
  html(BOLDEND); html(FONTEND); html(PEND); 
  html(TDEND); html(TREND); 

  html(TR); //inicio de fila
  html(TD1); //parámetros de cela: ancho, estilo borde
  //formato de párrafo: centrado, fonte arial, branca, tamaño 7
  html(PCENTER); html(BOLD); 
  html_fontarial(0xffffff,7);
  // valor luz aproximado
  if(LUM==0xffff) strcpy(cad1,"---"); //saida nula
  else 
    converte_luminosidade_texto(cad1,LUM); //función específica para convertir datos a texto
//  cliente.print(F("Luz: ")); cliente.print(cad1); cliente.print(F(" W/m<sup>2</sup>")); //W/m2
  cliente.print(F("Luz: ")); cliente.print(cad1); cliente.print(F(" lx")); //lux
  html(BOLDEND); html(FONTEND); html(PEND); 
  html(TDEND); html(TREND); 
  
  html(TABLEEND); 
  html(BR);
  html_fontarial(0xffffff,2);
  cliente.print(F("m&aacute;is info: <a href='http://codos.meteoproval.es'>http://codos.meteoproval.es</a>"));
  html(FONTEND);
  html(BODYEND); html(HTMLEND); 

}
/////////////////////////////////////////////////////////////////////////////////////////////////
// esta función envía o código html da páxina de configuración ip
// para non ocupar demasiada memoria emprega un conxunto de liñas predefinidas
// o parámetro bloquear vale 0 se os campos se poden modificar e 1 se non se pode
void paxina_html_presenta_configuracion(byte bloquear)
{
  byte n;
  
  html(HTTP_OK); //cabeceira da páxina
  
  html(HTML); //inicio de código html
  html(HEAD1); //<head> con content-type
  html(VIEWPORT); //orden para adaptarse ao tamaño de pantalla
  html(HEADEND); //fin de cabeceira
  html(BODY1); //inicio de texto con idioma e cor de fondo

  //cabeceira do formulario. Os parámetros indican o nome e a páxina destino
  html2par(FORM1,"formulario","conf3.htm");

  //engade unha etiqueta de conxunto de campos para activar ou desactivar en bloque
  //(os campos desactivados non se poden cambiar nin se envían os seus datos)
  cliente.print(F("<fieldset style='border: 0px' ")); 
  if(bloquear==1)  cliente.print(F("disabled='disabled'>")); else cliente.print(F(">"));

//entrada datos ip
//caixa de texto de lonxitude 3 caracteres, máximo 3 caracteres, patrón de filtrado para devolver valores 0-255
// A expresión regular seguinte permite: números que empecen por 0,1 e dous díxitos (entre 000 e 199), números entre 200 e 249 e números entre 250 e 255. 
// O primeiro grupo “[1-9]?\d” permite un número de 1 ou 2 cifras coa primeira opcional, así se evitan os ceros iniciais. NOTA: evitar a barra “\d”, poñer [0-9]:
// EXPRESIÓN REGULAR: ([1-9]?[0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])

  //formato de párrafo: centrado, fonte arial, branca, tamaño 5
  html_fontarial(0xffffff,5);
  cliente.println(F("<P><B>CONFIGURACI&Oacute;N</B></P>"));
  cliente.println(F("</font><P></P>"));

  //formato de párrafo: centrado, fonte arial, branca, tamaño 3
  html_fontarial(0xffffff,3);
  //crea campos de texto con nomes ip00,ip01... 
  cliente.print(F("<P>MEDIDOR</P>"));
  html_campo_ip(16,medidor_numero); html(BR); 
  cliente.print(F("<P>IP LOCAL</P>"));
  html_campo_ip(0,local_ip[0]); html(PUNTO); 
  html_campo_ip(1,local_ip[1]); html(PUNTO); 
  html_campo_ip(2,local_ip[2]); html(PUNTO); 
  html_campo_ip(3,local_ip[3]); html(BR); 
  cliente.print(F("<P>MASCARA</P>"));
  html_campo_ip(4,local_mask[0]); html(PUNTO); 
  html_campo_ip(5,local_mask[1]); html(PUNTO); 
  html_campo_ip(6,local_mask[2]); html(PUNTO); 
  html_campo_ip(7,local_mask[3]); html(BR); 
  cliente.print(F("<P>GATEWAY</P>"));
  html_campo_ip( 8,gw_ip[0]); html(PUNTO); 
  html_campo_ip( 9,gw_ip[1]); html(PUNTO); 
  html_campo_ip(10,gw_ip[2]); html(PUNTO); 
  html_campo_ip(11,gw_ip[3]); html(BR); 
  cliente.print(F("<P>DNS</P>"));
  html_campo_ip(12,dns_ip[0]); html(PUNTO); 
  html_campo_ip(13,dns_ip[1]); html(PUNTO); 
  html_campo_ip(14,dns_ip[2]); html(PUNTO); 
  html_campo_ip(15,dns_ip[3]); html(BR); 
  cliente.print(F("<P>SERVIDOR</P>"));
  html2par(INPUT2,"host",medidor_host); html(BR); 
  cliente.print(F("<P>RUTA</P>"));
  html2par(INPUT2,"ruta",medidor_ruta); html(BR); 

  if(bloquear==0) 
  { //engade botóns para enviar a información
    html(BR); html(BR);
    html2par(BUTTONOK,"0","ANULAR");
    html2par(BUTTONOK,"1","GARDAR");
    html2par(BUTTONOK,"2","CALIBRAR");    
  }
 
  cliente.print(F("</fieldset>")); //fin de lista de campos

  html(FONTEND); html(FORMEND); html(BODYEND); html(HTMLEND);
}

////////////////////////////////////////////////////////////////////////////////////////////
// función que presenta os novos parámetros de rede e pide confirmación
// a información se recibe na cadena global 'linea', co punteiro de inicio situado en '/'
// e remata en http (xa eliminado). Deste xeito queda o nome de páxina seguido das variables:
// "index.htm?ip00=111&ip01=11&ok=1  " 
// - as variables comezan con '?', levan '=' e van separadas por '&' excepto a última que leva ' '
// - en primeiro lugar se localiza '?' e a partir de aí busca todas as variables
// - se falta algunha se anula todo, se o formato é incorrecto tamén (número 0-255)
// - ademáis a última variable é 'ok' que vale 0 se os cambios se desbotan ou '1' se se aceptan
void paxina_html_cambia_configuracion(char *plin)
{
  byte res, n, datos[20];
  char *plin2,*plin3,*plin4,*plin5;

  res=1; //resultado da verificación, se vale 0 remata
  plin=strstr(plin,"?"); if(plin==NULL) res=0; else plin++;  // busca e salta '?'  
  if(res)
  { 
    //en primeiro lugar verifica se hai que calibrar o sensor (botón ok=2)
    //facémolo aquí para que se poida mandar unha liña curta ("conf2.htm?ok=2")
    // nese caso xa non segue porque non se van modificar o resto de parámetros
    plin2=strstr(plin,"ok=2"); if(plin2!=NULL) 
    { // CALIBRACIÓN DO SENSOR CO2
      sensor_co2_calibracion(); res=0; } 
    
    //bucle que recorre todas as variables 'ipnn='
    //(a variable 16 é o número de medidor)
    for (n=0;n<17;n++) 
    { sprintf(cad1,"ip%02d=",n); //crea nome de variable tipo 'ipnn='
      //busca variable, se non existe remata o bucle
      plin2=busca_variable(plin,cad1); if(plin2==NULL) { res=0; break; }
      datos[n]=converte_texto_byte(plin2);
      plin3=plin2+strlen(plin2); *plin3=' '; //quita marca de fin
    } // fin de bucle
    //buscar "host=" e "ruta="
    if(res) 
    { plin2=busca_variable(plin,"host="); plin4=plin2;
      if(plin2==NULL) res=0;  }
    if(res) 
    { plin3=plin2+strlen(plin2); *plin3=' '; //quita marca de fin
      plin2=busca_variable(plin,"ruta="); plin5=plin2;
      if(plin2==NULL) res=0; }

    //por último localiza variable 'ok=1' para gardar ou non os datos
    if(res) 
    { plin3=plin2+strlen(plin2); *plin3=' '; //quita marca de fin
      plin2=strstr(plin,"ok=1"); if(plin2==NULL) res=0; }

    //todo listo, modifica parámetros de rede e reinicia:
    if(res)
    { //copia datos a direccións ip
      local_ip[0]=datos[ 0]; dns_ip[0]=datos[12]; gw_ip[0]=datos[ 8]; local_mask[0]=datos[ 4];
      local_ip[1]=datos[ 1]; dns_ip[1]=datos[13]; gw_ip[1]=datos[ 9]; local_mask[1]=datos[ 5];
      local_ip[2]=datos[ 2]; dns_ip[2]=datos[14]; gw_ip[2]=datos[10]; local_mask[2]=datos[ 6];
      local_ip[3]=datos[ 3]; dns_ip[3]=datos[15]; gw_ip[3]=datos[11]; local_mask[3]=datos[ 7];
      // copia cadenas host e ruta. Primeiro hai que marcar o fin das cadenas (van seguidas)
      busca_variable(plin4,""); cambia_codigos_url(plin4); //marca fin e quita códigos "%xx"
      strcpy(medidor_host,plin4); //copia cadena
      busca_variable(plin5,""); cambia_codigos_url(plin5); //marca fin e quita códigos "%xx"
      strcpy(medidor_ruta,plin5); //copia cadena
      // copia número de medidor a variable
      medidor_numero=datos[16];
      // escribe nova configuración na memoria
      eeprom_escribe_configuracion();

      // reinicia rede
      http_inicio();
    } //fin de actualización de parámetros

  } // fin de busca de nomes

  paxina_html_presenta_configuracion(1); //presenta datos con bloqueo
  
}
////////////////////////////////////////////////////////////////////////////////////////////
// subfunción que localiza unha variable na cabeceira html e a delimita para lectura
// devolve punteiro á posición do valor da variable para conversión, ou NULL se erro
// o nome de variable contén '=' ó final
char* busca_variable(char *cad, char* nome)
{ char *plin, *plin2;
  //busca variable, se non existe devolve erro
  plin=strstr(cad,nome); if(plin==NULL) return NULL;
  //localiza marcadores de final '&' ou ' ', senón erro e sae
  plin=plin+strlen(nome); 
  plin2=strstr(plin,"&"); //busca '&'
  if(plin2==NULL) //se non está busca ' '
  { plin2=strstr(plin," "); 
    if(plin2==NULL) return NULL; } // se non atopa ' ' erro e sae
  *plin2=0; //marca fin de liña despóis do número
  return plin; //devolve inicio do valor
}
////////////////////////////////////////////////////////////////////////////////////////////
// subfunción que recibe unha cadena en formato url (caracteres especiais en formato $nn)
// e substitúe a secuencia '%2F' por '/' para recuperar a ruta correcta do servidor
// (non trata outros caracteres especiais, non se esperan)
// a función utiliza dous punteiros, o primeiro recorre a cadena buscando a secuencia 
// e o segundo vai copiando os caracteres (iguais ou modificados). 
// Os datos devólvense na mesma cadena porque o resultado ocupa igual ou menos que a inicial.
// tamén fixa o novo fin de cadena cun 0.  
void cambia_codigos_url(char *cad)
{
  char *pcad, c1, c2;
  //busca '%' e dous caracteres consecutivos mentres !=0 (fin)
  pcad=cad;
  while (*cad) 
  { if(*cad=='%') //localiza inicio de código url
    { cad++; c1=*cad; //díxito alto do código url
      if(c1>'9') c1-=7; c1&=0x0f;
      cad++; c2=*cad; //díxito baixo do código url
      if(c2>'9') c2-=7; c2&=0x0f;
      //combina valores e garda en posición final
      *pcad=(c1 << 4) | c2; }
    else *pcad=*cad; //se non é '%' deixa o carácter existente 
    cad++; pcad++; //avanza punteiros
  } //fin de while
  *pcad=0; //marca novo fin de cadena (ou o mesmo)
}
////////////////////////////////////////////////////////////////////////////////////////////
// funcións especiais que poden redefinirse

byte converte_texto_byte(char *cad)
{
  int ival=atoi(cad);
  return (byte)ival;
}
/////////////////////////////////////////////////////////////
// crea cadena de texto co valor de temperatura
// recibe un valor enteiro no rango 0..20000 
// que corresponde a (temperatura+100)*100
// formato de saída "-99.0" (4 díxitos, un decimal,
// eliminar ceros iniciais, con signo-)
void converte_temperatura_texto(char *cad, unsigned int tem)
{
  unsigned int coc,res;
  int ival;

  //sitúa o valor no rango correcto e engade signo (-)
  ival=(int)tem; ival=ival-10000;
  if(ival>=0) { tem=(unsigned int)ival; }
  else {ival=-ival; tem=(unsigned int)ival; *cad='-'; cad++; }
  coc=tem/10000; res=tem%10000; if(coc>0) { *cad=(char)coc+'0'; cad++; }
  coc=res/1000;  res=res%1000;  *cad=(char)coc+'0'; cad++;
  coc=res/100;   res=res%100;   *cad=(char)coc+'0'; cad++; 
  *cad='.'; cad++; //intercala punto decimal
  coc=res/10;    res=res%10;    *cad=(char)coc+'0'; cad++; //decimal 
//  *cad=(char)res+'0'; cad++;
  *cad=0; //0=marca de fin de cadena
}
/////////////////////////////////////////////////////////////
// crea cadena de texto co valor de humidade relativa
// recibe un valor enteiro no rango 0..10000 
// que corresponde á humidade*100
// formato de saída "100.0" (5 díxitos, un decimal,
// eliminar ceros iniciais, sen signo)
void converte_humidade_texto(char *cad, unsigned int hum)
{
  unsigned int coc,res;
  coc=hum/10000; res=hum%10000; if(coc>0) { *cad=(char)coc+'0'; cad++; }
  coc=res/1000;  res=res%1000;  *cad=(char)coc+'0'; cad++;
  coc=res/100;   res=res%100;   *cad=(char)coc+'0'; cad++; 
  *cad='.'; cad++; //intercala punto decimal
  coc=res/10;    res=res%10;    *cad=(char)coc+'0'; cad++; //decimal 
//  *cad=(char)res+'0'; cad++;
  *cad=0; //0=marca de fin de cadena
}
/////////////////////////////////////////////////////////////
// crea cadena de texto co valor de dióxido de carbono
// recibe un valor enteiro no rango 0.10000
// que corresponde á concentración en ppm (máx 2000)
void converte_co2_texto(char *cad, unsigned int co2)
{
  unsigned int coc,res;
  coc=co2/10000; res=co2%10000; if(coc>0) { *cad=(char)coc+'0'; cad++; }
  coc=res/1000;  res=res%1000;  *cad=(char)coc+'0'; cad++;
  coc=res/100;   res=res%100;   *cad=(char)coc+'0'; cad++; 
  coc=res/10;    res=res%10;    *cad=(char)coc+'0'; cad++;
  *cad=(char)res+'0'; cad++;
  *cad=0; //0=marca de fin de cadena
}
/////////////////////////////////////////////////////////////
// crea cadena de texto co valor de enerxía luminosa
// recibe un valor enteiro no rango 0..10000 (máx 1000)
// que corresponde á enerxía da luz en W/m2
void converte_luminosidade_texto(char *cad, unsigned int lum)
{
  unsigned int coc,res;
  coc=lum/10000; res=lum%10000; if(coc>0) { *cad=(char)coc+'0'; cad++; }
  coc=res/1000;  res=res%1000;  *cad=(char)coc+'0'; cad++;
  coc=res/100;   res=res%100;   *cad=(char)coc+'0'; cad++; 
  coc=res/10;    res=res%10;    *cad=(char)coc+'0'; cad++;
  *cad=(char)res+'0'; cad++;
  *cad=0; //0=marca de fin de cadena
}


